/**
 * ocLazyLoad - Load modules on demand (lazy load) with angularJS
 * @version v0.3.0
 * @link https://github.com/ocombe/ocLazyLoad
 * @license MIT
 * @author Olivier Combe <olivier.combe@gmail.com>
 */
!function(){"use strict";function e(e){var n=[];return angular.forEach(e.requires,function(e){-1===l.indexOf(e)&&n.push(e)}),n}function n(e){try{return angular.module(e)}catch(n){if(/No module/.test(n)||n.message.indexOf("$injector:nomod")>-1)return!1}}function r(e){try{return angular.module(e)}catch(n){throw(/No module/.test(n)||n.message.indexOf("$injector:nomod")>-1)&&(n.message='The module "'+e+'" that you are trying to load does not exist. '+n.message),n}}function a(e,n){if(n){var r,a,o,i;for(r=0,a=n.length;a>r;r++)if(o=n[r],angular.isArray(o)){if(!e.hasOwnProperty(o[0]))throw new Error("unsupported provider "+o[0]);i=e[o[0]],t(o[2][0])&&i[o[1]].apply(i,o[2])}}}function o(e,n){if(n){var r,t,u,c=[];for(r=n.length-1;r>=0;r--)t=n[r],"string"!=typeof t&&(t=i(t)),t&&(u=angular.module(t),-1===l.indexOf(t)&&(l.push(t),o(e,u.requires),c=c.concat(u._runBlocks)),a(e,u._invokeQueue),a(e,u._configBlocks),f("ocLazyLoad.moduleLoaded",t),n.pop());var s=e.getInstanceInjector();angular.forEach(c,function(e){s.invoke(e)})}}function t(e){var n=!1;if(angular.isString(e))-1===c.indexOf(e)&&(n=!0,c.push(e),f("ocLazyLoad.componentLoaded",e));else{if(!angular.isObject(e))return!0;angular.forEach(e,function(e){angular.isString(e)&&-1===c.indexOf(e)&&(n=!0,c.push(e))})}return n}function i(e){if(null===e)return null;var n=null;return"string"==typeof e?n=e:"object"==typeof e&&e.hasOwnProperty("name")&&"string"==typeof e.name&&(n=e.name),n}function u(e){function n(e){return e&&o.push(e)}var r,a,o=[e],i=["ng:app","ng-app","x-ng-app","data-ng-app"],u=/\sng[:\-]app(:\s*([\w\d_]+);?)?\s/;angular.forEach(i,function(r){i[r]=!0,n(document.getElementById(r)),r=r.replace(":","\\:"),e.querySelectorAll&&(angular.forEach(e.querySelectorAll("."+r),n),angular.forEach(e.querySelectorAll("."+r+"\\:"),n),angular.forEach(e.querySelectorAll("["+r+"]"),n))}),angular.forEach(o,function(n){if(!r){var o=" "+e.className+" ",t=u.exec(o);t?(r=n,a=(t[2]||"").replace(/\s+/g,",")):angular.forEach(n.attributes,function(e){!r&&i[e.name]&&(r=n,a=e.value)})}}),r&&!function c(e){if(-1===l.indexOf(e)){l.push(e);var n,r,a,o=angular.module(e),i=o._invokeQueue;for(n=0,r=i.length;r>n;n++)a=i[n],angular.isArray(a)&&t(a[2][0]);if(angular.isDefined(o._configBlocks)){var n,r,a,i=o._configBlocks;for(n=0,r=i.length;r>n;n++)a=i[n],angular.isArray(a)&&t(a[2][0])}angular.forEach(o.requires,c)}}(a)}var l=["ng"],c=[],s=angular.module("oc.lazyLoad",["ng"]),f=angular.noop;s.provider("$ocLazyLoad",["$controllerProvider","$provide","$compileProvider","$filterProvider","$injector","$animateProvider",function(a,t,c,s,d,g){var p,h,m,y={},v={$controllerProvider:a,$compileProvider:c,$filterProvider:s,$provide:t,$injector:d,$animateProvider:g},L=document.getElementsByTagName("head")[0]||document.getElementsByTagName("body")[0],$=!1,E=!1;u(angular.element(window.document)),this.$get=["$timeout","$log","$q","$templateCache","$http","$rootElement","$rootScope","$cacheFactory",function(a,t,u,c,s,d,g,j){var w,O=j("ocLazyLoad");$||(t={},t.error=angular.noop,t.warn=angular.noop),v.getInstanceInjector=function(){return w?w:w=d.data("$injector")},f=function(e,n){E&&g.$broadcast(e,n)};var x=function(e,n,r){var a,o,t=u.defer(),i=function(e){var n=(new Date).getTime();return-1!=e.indexOf("?")?"&"===e.substring(0,e.length-1)?e+"_dc="+n:e+"&_dc="+n:e+"?_dc="+n};switch(e){case"css":a=document.createElement("link"),a.type="text/css",a.rel="stylesheet",a.href=r.cache===!1?i(n):n;break;case"js":a=document.createElement("script"),a.src=r.cache===!1?i(n):n;break;default:t.reject(new Error('Requested type "'+e+'" is not known. Could not inject "'+n+'"'))}return a.onload=a.onreadystatechange=function(){a.readyState&&!/^c|loade/.test(a.readyState)||o||(a.onload=a.onreadystatechange=null,o=1,angular.isUndefined(O.get(n))&&O.put(n,!0),f("ocLazyLoad.fileLoaded",n),t.resolve())},a.onerror=function(){t.reject(new Error("Unable to load "+n))},a.async=1,L.insertBefore(a,L.lastChild),t.promise};angular.isUndefined(p)&&(p=function(e,n,r){var a=[];angular.forEach(e,function(e){a.push(x("js",e,r))}),u.all(a).then(function(){n()},function(e){n(e)})},p.ocLazyLoadLoader=!0),angular.isUndefined(h)&&(h=function(e,n,r){var a=[];angular.forEach(e,function(e){a.push(x("css",e,r))}),u.all(a).then(function(){n()},function(e){n(e)})},h.ocLazyLoadLoader=!0),angular.isUndefined(m)&&(m=function(e,n,r){angular.isString(e)&&(e=[e]);var a=[];return angular.forEach(e,function(e){var n=u.defer();a.push(n.promise),s.get(e,r).success(function(r){angular.forEach(angular.element(r),function(e){"SCRIPT"===e.nodeName&&"text/ng-template"===e.type&&c.put(e.id,e.innerHTML)}),angular.isUndefined(O.get(e))&&O.put(e,!0),n.resolve()}).error(function(r){var a='Error load template "'+e+'": '+r;t.error(a),n.reject(new Error(a))})}),u.all(a).then(function(){n()},function(e){n(e)})},m.ocLazyLoadLoader=!0);var P=function(e,n){var r=[],a=[],o=[],i=[];if(angular.forEach(e,function(e){(angular.isUndefined(O.get(e))||n.cache===!1)&&(/\.css[^\.]*$/.test(e)?r.push(e):/\.(htm|html)[^\.]*$/.test(e)?a.push(e):o.push(e))}),r.length>0){var l=u.defer();h(r,function(e){angular.isDefined(e)&&h.hasOwnProperty("ocLazyLoadLoader")?(t.error(e),l.reject(e)):l.resolve()},n),i.push(l.promise)}if(a.length>0){var c=u.defer();m(a,function(e){angular.isDefined(e)&&m.hasOwnProperty("ocLazyLoadLoader")?(t.error(e),c.reject(e)):c.resolve()},n),i.push(c.promise)}if(o.length>0){var s=u.defer();p(o,function(e){angular.isDefined(e)&&p.hasOwnProperty("ocLazyLoadLoader")?(t.error(e),s.reject(e)):s.resolve()},n),i.push(s.promise)}return u.all(i)};return{getModuleConfig:function(e){return y[e]?y[e]:null},setModuleConfig:function(e){return y[e.name]=e,e},getModules:function(){return l},loadTemplateFile:function(e,n){return P(e,n)},load:function(c,s){var f,d,g=this,p=null,h=[],m=[],y=u.defer();if(angular.isUndefined(s)&&(s={}),angular.isArray(c))return angular.forEach(c,function(e){m.push(g.load(e,s))}),u.all(m).then(function(){y.resolve(c)}),y.promise;if(f=i(c),"string"==typeof c?(p=g.getModuleConfig(c),p||(p={files:[c]},f=null)):"object"==typeof c&&(p=g.setModuleConfig(c)),null===p?(d='Module "'+f+'" is not configured, cannot load.',t.error(d),y.reject(new Error(d))):angular.isDefined(p.template)&&(angular.isUndefined(p.files)&&(p.files=[]),angular.isString(p.template)?p.files.push(p.template):angular.isArray(p.template)&&p.files.concat(p.template)),h.push=function(e){-1===this.indexOf(e)&&Array.prototype.push.apply(this,arguments)},angular.isDefined(f)&&n(f)&&-1!==l.indexOf(f)&&(h.push(f),angular.isUndefined(p.files)))return y.resolve(),y.promise;var L=function $(a){var o,l,c,f=[];if(o=i(a),null===o)return u.when();try{l=r(o)}catch(d){var p=u.defer();return t.error(d.message),p.reject(d),p.promise}return c=e(l),angular.forEach(c,function(e){if("string"==typeof e){var r=g.getModuleConfig(e);if(null===r)return void h.push(e);e=r}return n(e.name)||-1!==h.indexOf(e.name)?void("string"!=typeof a&&t.warn('Module "',o,'" attempted to redefine configuration for dependency "',e.name,'"\nExisting:',g.getModuleConfig(e.name),"Ignored:",e)):("object"==typeof e&&(e.hasOwnProperty("name")&&e.name&&(g.setModuleConfig(e),h.push(e.name)),e.hasOwnProperty("css")&&0!==e.css.length&&angular.forEach(e.css,function(e){x("css",e)})),void(e.hasOwnProperty("files")&&0!==e.files.length&&e.files&&f.push(P(e.files,s).then(function(){return $(e)}))))}),u.all(f)};return P(p.files,s).then(function(){null===f?y.resolve(c):(h.push(f),L(f).then(function(){try{o(v,h)}catch(e){return t.error(e.message),void y.reject(e)}a(function(){y.resolve(c)})},function(e){a(function(){y.reject(e)})}))},function(e){y.reject(e)}),y.promise}}}],this.config=function(e){if(p=e.jsLoader||e.asyncLoader,angular.isDefined()&&!angular.isFunction(p))throw"The js loader needs to be a function";if(angular.isDefined(e.cssLoader)&&(h=e.cssLoader),angular.isDefined(e.templatesLoader)&&(m=e.templatesLoader),angular.isDefined(e.loadedModules)){var n=function(e){l.indexOf(e)<0&&(l.push(e),angular.forEach(angular.module(e).requires,n))};angular.forEach(e.loadedModules,n)}angular.isDefined(e.modules)&&(angular.isArray(e.modules)?angular.forEach(e.modules,function(e){y[e.name]=e}):y[e.modules.name]=e.modules),angular.isDefined(e.debug)&&($=e.debug),angular.isDefined(e.events)&&(E=e.events)}}]),s.directive("ocLazyLoad",["$http","$log","$ocLazyLoad","$compile","$timeout","$templateCache","$animate",function(e,n,r,a,o,t,i){return{restrict:"A",terminal:!0,priority:401,transclude:"element",controller:angular.noop,compile:function(){return function(e,n,a,o,t){function u(){l&&(l.$destroy(),l=null),n.html("")}{var l,c=e.$eval(a.ocLazyLoad);c&&c.onload?c.onload:""}e.$watch(a.ocLazyLoad,function(a){angular.isDefined(a)?r.load(a).then(function(){t(e,function(e){i.enter(e,null,n)})}):u()},!0)}}}}])}();